ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.11 by root, Mon Mar 12 14:55:43 2007 UTC vs.
Revision 1.88 by root, Tue Oct 5 23:26:44 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
24use Digest::MD5; 53use Coro::Channel;
54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 59
26sub usage { 60sub usage {
27 warn <<EOF; 61 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 63 [--install-arch path]
40my $VERBOSE = 1; 74my $VERBOSE = 1;
41my $CACHE = 0; 75my $CACHE = 0;
42my $FORCE; 76my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
45 96
46END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
47 98
48Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hahs collinion, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
50 123
51mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
52 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
53 126
54sub fork_sub(&) { 127sub fork_sub(&) {
67} 140}
68 141
69sub inst_maps($) { 142sub inst_maps($) {
70 my (undef, $path) = @_; 143 my (undef, $path) = @_;
71 144
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 146
74 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
77 } 150 }
78 151
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
80} 159}
81 160
161sub autoglyph {
162 my ($stem, $face) = @_;
163
164 if ($stem =~ /^wall\/|Nimwall/) {
165# warn $stem;
166 "+"
167 } elsif ($stem =~ /^floor\/|^ground\/|Nimfloor/) {
168 "."
169 } elsif ($stem =~ /^player\//) {
170 "@"
171 } else {
172 substr $stem, 0, 1
173 }
174}
175
82{ 176{
83 our %PNG32; 177 our %ANIMINFO;
84 our %FACEINFO; 178 our %FACEINFO;
179 our %RESOURCE;
85 our @ARC; 180 our @ARC;
181 our %ARC;
182 our $TRS;
86 our $NFILE; 183 our $NFILE;
87 our %ANIM; 184 our $PATH;
88 185
89 our (@png, @trs, @arc); # files we are interested in 186 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
90 187
188 our $c_arc = new Coro::Channel;
189 our $c_trs = new Coro::Channel;
190 our $c_res = new Coro::Channel;
191
192 our @c_png;
193
91 sub commit_png { 194 sub commit_png($$$$) {
92 my ($name, $data) = @_; 195 my ($stem, $name, $data, $T) = @_;
93 196
94 $PNG32{$name} = $data; 197 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
95 $FACEINFO{$name} ||= {}; 198 $FACEINFO{$name}{"data$T"} = $data;
96 } 199 }
97 200
98 sub process_png { 201 sub process_png {
99 while (@png) { 202 while (@c_png) {
100 my $path = pop @png; 203 my ($path, $delete) = @{pop @c_png};
101 204
102 my $png; 205 my $png;
103 aio_lstat $path; 206 aio_lstat $path;
104 my ($size, $mtime) = (stat _)[7,9]; 207 my ($size, $mtime) = (stat _)[7,9];
105 208
106 if (0 > aio_load $path, $png) { 209 if (0 > aio_load $path, $png) {
107 warn "$path: $!, skipping.\n"; 210 warn "$path: $!, skipping.\n";
108 next; 211 next;
109 } 212 }
110 213
214 my $stem = $path;
215 my $T;
216
217 if ($stem =~ s/\.32x32\.png~?$//) {
218 $T = 32;
219 } elsif ($stem =~ s/\.64x64\.png~?$//) {
220 $T = 64;
221 } else {
222 warn "$path: weird filename, skipping.\n";
223 next;
224 }
225
111 # quickly extract width and height of the (necessarily PNG) image 226 # quickly extract width and height of the (necessarily PNG) image
112 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 227 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
113 warn "$path: not a recongized png file, skipping.\n"; 228 warn "$path: not a recognized png file, skipping.\n";
114 next; 229 next;
115 } 230 }
116 231
117 my ($w, $h) = unpack "NN", $1; 232 my ($w, $h) = unpack "NN", $1;
118
119 (my $face = $path) =~ s/^.*\///;
120 my $T = 32;
121
122 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
123 warn "$path: weird filename, skipping.\n";
124 next;
125 }
126 233
127 if ($w < $T || $h < $T) { 234 if ($w < $T || $h < $T) {
128 warn "$path: too small ($w $h), skipping.\n"; 235 warn "$path: too small ($w $h), skipping.\n";
129 next; 236 next;
130 } 237 }
132 if ($w % $T || $h % $T) { 239 if ($w % $T || $h % $T) {
133 warn "$path: weird png size ($w $h), skipping.\n"; 240 warn "$path: weird png size ($w $h), skipping.\n";
134 next; 241 next;
135 } 242 }
136 243
244 (my $base = $stem) =~ s/^.*\///;
245
246 my $fi = $FACEINFO{$base};
247 unless ($fi) {
248 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
249 #next;
250 }
251
252 my $arc = $fi->{arc} || { };
253
254 unless ($path =~ /~$/) {
255 # possibly enlarge
256 if (0 > aio_stat "$stem.64x64.png") {
257 my $other = "$stem.64x64.png~";
258
259 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
260 fork_sub {
261 my $CROP;
262 my $SRC = "png:\Q$path\E";
263
264 my $is_floor = $arc->{is_floor};
265 my $is_wall = 0;
266
267 my ($wall_pfx, $wall_dir, $wall_sfx);
268
269 if (
270 !$is_floor
271 && !$arc->{alive}
272 && $arc->{move_block} eq "all"
273 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
274 ) {
275 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
276
277 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
278 $is_wall = 1;
279 }
280 }
281
282 if ($is_wall || $is_floor) {
283 # add a 4px border and add other images around it
284 $CROP = "-shave 8x8 +repage";
285
286 $w += 8;
287 $h += 8;
288
289 $SRC = "-size ${w}x${h} xc:transparent";
290 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
291
292 # 8 surrounding images
293 for (
294 # x y b r0 r1
295 [-1, -1, 0, 6],
296 [ 0, -1, 1, 10, 14],
297 [+1, -1, 0, 12],
298
299 [-1, 0, 8, 5, 7],
300 #
301 [+1, 0, 2, 5, 13],
302
303 [-1, +1, 0, 3],
304 [ 0, +1, 4, 10, 11],
305 [+1, +1, 0, 9],
306 ) {
307 my ($x, $y, $d, $r0, $r1) = @$_;
308
309 my $tile = $is_floor ? $path
310 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
311 : die;
312
313 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
314 "\Q$tile",
315 $x * ($w - 8) + 4,
316 $y * ($h - 8) + 4;
317 }
318 }
319
320 system "convert -depth 8 $SRC rgba:-"
321 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
322 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
323 and die "convert/cfhq2xa pipeline error: status $? ($!)";
324 system $OPTIPNG, "-i0", "-q", "$other~";
325 die "$other~ has zero size, aborting." unless -s "$other~";
326 rename "$other~", $other;
327 };
328 }
329
330 push @c_png, [$other, !$CACHE];
331 }
332
333 # possibly scale down
334 if (0 > aio_stat "$stem.32x32.png") {
335 my $other = "$stem.32x32.png~";
336
337 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
338 fork_sub {
339 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
340 system $OPTIPNG, "-i0", "-q", "$other~";
341
342 # reduce smoothfaces >10000 bytes
343 # obsolete, no longer required
344 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
345 my $ncolor = 256;
346 while () {
347 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
348 system $OPTIPNG, "-i0", "-q", "$other~~";
349 last if 10000 > -s "$other~~";
350 $ncolor = int $ncolor * 0.9;
351 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
352 }
353
354 printf "reduced %s from %d to %d bytes using %d colours.\n",
355 $other, -s "$other~", -s "$other~~", $ncolor
356 if $VERBOSE >= 2;
357 rename "$other~~", "$other~";
358 }
359
360 die "$other~ has zero size, aborting." unless -s "$other~";
361 rename "$other~", $other;
362 };
363 }
364
365 #warn "scaled down $path to $other\n";#d#
366 push @c_png, [$other, !$CACHE];
367 }
368 }
369
370 (my $face = $stem) =~ s/^.*\///;
371
372 # split all bigfaces, but avoid smoothfaces (*_S)
137 if (($w > $T || $h > $T) && $face !~ /_S\./) { 373 if (($w > $T || $h > $T) && $face !~ /_S\./) {
138 # split 374 # split
139 my @tile; 375 my @tile;
140 for my $x (0 .. (int $w / $T) - 1) { 376 for my $x (0 .. (int $w / $T) - 1) {
141 for my $y (0 .. (int $h / $T) - 1) { 377 for my $y (0 .. (int $h / $T) - 1) {
155 ( 391 (
156 "(", 392 "(",
157 "+clone", 393 "+clone",
158 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 394 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
159 "+repage", 395 "+repage",
396 -quality => "00",
160 -write => "png:$_->[2]~", 397 -write => "png32:$_->[2]~",
161 "+delete", 398 "+delete",
162 ")", 399 ")",
163 ) 400 )
164 } @todo), 401 } @todo),
165 "null:"; 402 "null:";
169 close $convert; 406 close $convert;
170 407
171 # pass 2, optimise, and rename 408 # pass 2, optimise, and rename
172 for (@todo) { 409 for (@todo) {
173 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 410 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
411 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
174 rename "$_->[2]~", $_->[2]; 412 rename "$_->[2]~", $_->[2];
175 } 413 }
176 }; 414 };
177 } 415 }
178 416
182 420
183 if (0 > aio_load $file, $tile) { 421 if (0 > aio_load $file, $tile) {
184 die "$path: unable to read tile +$x+$y, aborting.\n"; 422 die "$path: unable to read tile +$x+$y, aborting.\n";
185 } 423 }
186 IO::AIO::aio_unlink $file unless $CACHE; 424 IO::AIO::aio_unlink $file unless $CACHE;
187 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 425 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
188 } 426 }
189 } else { 427 } else {
190 # use as-is (either small, use smooth) 428 # use as-is (either small, use smooth)
191 commit_png $face, $png; 429 commit_png $stem, $face, $png, $T;
192 } 430 }
431
432 aio_unlink $path if $delete;
193 } 433 }
194 } 434 }
195 435
196 sub process_arc { 436 sub process_arc {
197 while (@arc) { 437 while (my $job = $c_arc->get) {
198 my ($dir, $file) = @{pop @arc}; 438 my ($dir, $file) = @$job;
199 439
200 my $arc; 440 my $arc;
201 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 441 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
202 442
203 my $arc = read_arch "$dir/$file"; 443 my $arc = read_arch "$dir/$file";
204 for my $o (values %$arc) { 444 for my $o (values %$arc) {
205 push @ARC, $o; 445 push @ARC, $o;
446 for (my $m = $o; $m; $m = $m->{more}) {
447 $ARC{$m->{_name}} = $m;
448 }
206 449
207 $o->{editor_folder} = $dir; 450 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
208 451
209 my $visibility = delete $o->{visibility}; 452 my $visibility = delete $o->{visibility};
210 my $magicmap = delete $o->{magicmap}; 453 my $magicmap = delete $o->{magicmap};
454 my $glyph = delete $o->{glyph};
211 455
212 # find upper left corner :/ 456 # find upper left corner :/
213 # omg, this is sooo broken 457 # omg, this is sooo broken
214 my ($dx, $dy); 458 my ($dx, $dy);
215 for (my $o = $o; $o; $o = $o->{more}) { 459 for (my $o = $o; $o; $o = $o->{more}) {
221 my $x = $o->{x} - $dx; 465 my $x = $o->{x} - $dx;
222 my $y = $o->{y} - $dy; 466 my $y = $o->{y} - $dy;
223 467
224 my $ext = $x|$y ? "+$x+$y" : ""; 468 my $ext = $x|$y ? "+$x+$y" : "";
225 469
226 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 470 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
227 471
228 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 472 $visibility = delete $o->{visibility} if exists $o->{visibility};
229 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 473 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
474 $glyph = delete $o->{glyph} if exists $o->{glyph};
230 475
231 my $anim = delete $o->{anim}; 476 my $anim = delete $o->{anim};
232 477
233 if ($anim) { 478 if ($anim) {
479 # possibly add $ext to the animation name to avoid
480 # the need to specify archnames for all parts
481 # of a multipart archetype.
234 $o->{animation} = "$o->{_name}"; 482 $o->{animation} = "$o->{_name}";
483 my $facings = 1;
484 my @frames;
235 485
236 for (@$anim) { 486 for (@$anim) {
237 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 487 if (/^facings\s+(\d+)/) {
488 $facings = $1*1;
489 } elsif (/^blank.x11$|^empty.x11$/) {
490 push @frames, $_;
491 } else {
492 push @frames, "$_$ext";
493 }
238 } 494 }
239 495
240 $ANIM{"$o->{_name}$ext"} = 496 $ANIMINFO{$o->{animation}} = {
241 join "", map "$_\n", 497 facings => $facings,
242 "anim $o->{_name}", 498 frames => \@frames,
243 @$anim, 499 };
244 "mina";
245 } 500 }
246 501
247 for my $face ($o->{face} || (), @{$anim || []}) { 502 for ($o->{face} || (), @{$anim || []}) {
248 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 503 next if /^facings\s/;
249 504
505 my $face = $_;
506 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
507
250 my $info = $FACEINFO{$face} ||= {}; 508 my $info = $FACEINFO{$face} ||= { };
509 $info->{arc} = $o;
510
511 next if $face =~ /^blank.x11$|^empty.x11$/;
251 512
252 $info->{visibility} = $visibility if defined $visibility; 513 $info->{visibility} = $visibility if defined $visibility;
253 $info->{magicmap} = $magicmap if defined $magicmap; 514 $info->{magicmap} = $magicmap if defined $magicmap;
515 $info->{glyph} = $glyph if defined $glyph;
254 } 516 }
517
518 if (my $smooth = delete $o->{smoothface}) {
519 my %kv = split /\s+/, $smooth;
520 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
521 while (my ($face, $smooth) = each %kv) {
522 $FACEINFO{$smooth}{arc} = $o;
523
524 $FACEINFO{$face}{smooth} = $smooth;
525 $FACEINFO{$face}{smoothlevel} = $level;
526 }
527 }
255 } 528 }
256 } 529 }
257 } 530 }
258 } 531 }
259 532
260 sub process_trs { 533 sub process_trs {
261 while (@trs) { 534 while (my $job = $c_trs->get) {
262 my ($dir, $file) = @{pop @trs}; 535 my ($dir, $file) = @$job;
536 my $path = "$dir/$file";
537
538 my $trs;
539 if (0 > aio_load $path, $trs) {
540 warn "$path: $!, skipping.\n";
541 next;
542 }
543
544 $TRS .= $trs;
545 }
546 }
547
548 my %FILECACHE;
549
550 sub load_cached($;$) {
551 unless (exists $FILECACHE{$_[0]}) {
552 my $data;
553 if (0 < aio_load $_[0], $data) {
554 if ($_[1]) {
555 $data = eval { $_[1]->($data) };
556 warn "$_[0]: $@" if $@;
557 }
558 }
559
560 $FILECACHE{$_[0]} = $data;
561 }
562
563 $FILECACHE{$_[0]}
564 }
565
566 sub process_res {
567 while (my $job = $c_res->get) {
568 my ($dir, $file, $type) = @$job;
569
570 my $data;
571 aio_load "$dir/$file", $data;
572
573 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
574
575 utf8::decode $dir;
576 utf8::decode $file;
577
578 # a meta file for resources is now mandatory
579 unless (exists $meta->{$file}) {
580 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
581 next;
582 }
583
584 $meta = {
585 %{ $meta->{"" } || {} },
586 %{ $meta->{$file} || {} },
587 };
588
589 if ($meta->{license} =~ s/^#//) {
590 $meta->{license} = ({
591 "pd" => "Public Domain",
592 "gpl" => "GNU General Public License, version 3.0 or any later",
593 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
594 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
595 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
596 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
597 })->{$meta->{license}}
598 || warn "$dir/$file: license tag '$meta->{license}' not found.";
599 }
600
601 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
602 ($meta->{author} = $1) =~ s/_/ /g;
603 }
604
605 $file =~ s/\.res$//;
606 $file =~ s/\.(ogg|wav|jpg|png)$//;
607
608 substr $dir, 0, 1 + length $PATH, "";
609
610 if (my $filter = $meta->{cfutil_filter}) {
611 if ($filter eq "yaml2json") {
612 $data = JSON::XS::encode_json YAML::XS::Load $data;
613 } elsif ($filter eq "json2json") {
614 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
615 } elsif ($filter eq "perl2json") {
616 $data = eval $data; die if $@;
617 $data = JSON::XS::encode_json $data;
618 } else {
619 warn "$dir/$file: unknown filter $filter, skipping\n";
620 }
621 }
622
623 $RESOURCE{"$dir/$file"} = {
624 type => (exists $meta->{type} ? delete $meta->{type} : $type),
625 data => $data,
626 %$meta ? (meta => $meta) : (),
627 };
263 } 628 }
264 } 629 }
265 630
266 sub find_files; 631 sub find_files;
267 sub find_files { 632 sub find_files {
270 IO::AIO::aioreq_pri 4; 635 IO::AIO::aioreq_pri 4;
271 IO::AIO::aio_scandir $path, 4, sub { 636 IO::AIO::aio_scandir $path, 4, sub {
272 my ($dirs, $nondirs) = @_; 637 my ($dirs, $nondirs) = @_;
273 638
274 find_files "$path/$_" 639 find_files "$path/$_"
275 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 640 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
641
642 my $dir = $path;
643 substr $dir, 0, 1 + length $PATH, "";
276 644
277 for my $file (@$nondirs) { 645 for my $file (@$nondirs) {
646 if ($dir =~ /^music(?:\/|$)/) {
647 $c_res->put ([$path, $file, 3]) # FT_MUSIC
648 if $file =~ /\.(ogg)$/;
649
650 } elsif ($dir =~ /^sound(?:\/|$)/) {
651 $c_res->put ([$path, $file, 5]) # FT_SOUND
652 if $file =~ /\.(wav|ogg)$/;
653
654 } elsif ($dir =~ /^res(?:\/|$)/) {
655 if ($file =~ /\.(jpg|png)$/) {
656 $c_res->put ([$path, $file, 0]) # FT_FACE
657 } elsif ($file =~ /\.(res)$/) {
658 $c_res->put ([$path, $file, 6]) # FT_RSRC
659 } else {
660 $c_res->put ([$path, $file, undef]);
661 }
662
278 if ($file =~ /\.png$/) { 663 } elsif ($file =~ /\.png$/) {
279 push @png, "$path/$file"; 664 push @c_png, ["$path/$file", 0];
665
280 } elsif ($file =~ /\.trs$/) { 666 } elsif ($file =~ /\.trs$/) {
281 push @trs, [$path, $file]; 667 $c_trs->put ([$path, $file]);
668
282 } elsif ($file =~ /\.arc$/) { 669 } elsif ($file =~ /\.arc$/) {
283 push @arc, [$path, $file]; 670 $c_arc->put ([$path, $file]);
671
284 } else { 672 } else {
285 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 673 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
286 } 674 }
287 } 675 }
288 }; 676 };
677 }
678
679 sub generate_plurals {
680# use Lingua::EN::Inflect ();
681# Lingua::EN::Inflect::classical;
682# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
683# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
684#
685# for my $a (@ARC) {
686# my $name = $a->{name} || $a->{_name};
687#
688# next unless $a->{name_pl};
689# next if $a->{invisible};
690# next if $a->{is_floor};
691# next if $a->{no_pick};
692#
693# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
694# my $pl = $test =~ /^(?:eq|p:.)$/
695# ? $name
696# : Lingua::EN::Inflect::PL $name;
697#
698# if ($pl ne $a->{name_pl}) {
699# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
700# }
701# }
289 } 702 }
290 703
291 sub inst_arch($) { 704 sub inst_arch($) {
292 my (undef, $path) = @_; 705 my (undef, $path) = @_;
293 706
707 $PATH = $path;
708
709 print "\n",
294 print "installing '$path' to '$DATADIR'\n\n"; 710 "Installing '$path' to '$DATADIR'\n",
711 "\n",
712 "This can take a long time if you run this\n",
713 "for the first time or do not use --cache.\n",
714 "\n",
715 "Unless you run verbosely, all following warning\n",
716 "or error messages indicate serious problems.\n",
717 "\n";
295 718
296 if (!-d "$path/treasures") { 719 if (!-d "$path/treasures") {
297 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 720 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
298 exit 1 unless $FORCE; 721 exit 1 unless $FORCE;
299 } 722 }
300 723
724 print "scanning files...\n" if $VERBOSE;
725
301 find_files $path; 726 find_files $path;
727
728 my @a_arc = map +(async \&process_arc), 1..2;
729 my @a_res = map +(async \&process_res), 1..2;
730 my @a_trs = map +(async \&process_trs), 1..2;
731
302 IO::AIO::flush; 732 IO::AIO::flush;
303 733
304 $_->join for ( 734 $c_res->shutdown;
305 (async \&process_png), (async \&process_png), 735 $c_arc->shutdown;
306 (async \&process_trs), (async \&process_trs), 736 $c_trs->shutdown;
307 (async \&process_arc), (async \&process_arc),
308 );
309 737
738 print "start file scan, arc, res processing...\n" if $VERBOSE;
739
740 $_->join for @a_arc; # need to parse all archetypes before png processing
741
742 print "end arc, start png processing...\n" if $VERBOSE;
743
744 # eight png crunchers work fine for my 4x smp machine
745 my @a_png = map +(async \&process_png), 1..8;
746
747 $_->join for (@a_trs, @a_res, @a_png);
748
749 print "scanning done, processing results...\n" if $VERBOSE;
310 { 750 {
311 open my $fh, ">:utf8", "$DATADIR/animations~" 751 # remove path prefix from editor_folder
312 or die "$DATADIR/animations~: $!"; 752 $_->{editor_folder} =~ /^\x00/
313 print $fh join "", map $ANIM{$_}, sort keys %ANIM 753 and substr $_->{editor_folder}, 0, 2 + length $path, ""
754 for values %ARC;
755
756 print "resolving inheritance tree...\n" if $VERBOSE;
757 # resolve inherit
758 while () {
759 my $progress;
760 my $loop;
761
762 for my $o (values %ARC) {
763 for my $other (split /,/, $o->{inherit}) {
764 if (my $s = $ARC{$other}) {
765 if ($s->{inherit}) {
766 $loop = $s;
767 } else {
768 delete $o->{inherit};
769 my %s = %$s;
770 delete @s{qw(_name more name name_pl)};
771 %$o = ( %s, %$o );
772 ++$progress;
773 }
774 } else {
775 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
776 delete $ARC{$o->{_name}};
777 }
778 }
779 }
780
781 unless ($progress) {
782 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
783 if $loop;
784
785 last;
786 }
314 } 787 }
315 788
316 { 789 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
790 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
791
792 print "generating plurals...\n" if $VERBOSE;
793 generate_plurals;
794
795 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
317 open my $fh, ">:utf8", "$DATADIR/archetypes~" 796 open my $fh, ">:utf8", "$DATADIR/archetypes~"
318 or die "$DATADIR/archetypes~: $!"; 797 or die "$DATADIR/archetypes~: $!";
319 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 798 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
320 print $fh Crossfire::archlist_to_string \@ARC;
321 } 799 }
322 800
323 { 801 {
802 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
803 open my $fh, ">:utf8", "$DATADIR/treasures~"
804 or die "$DATADIR/treasures~: $!";
805 print $fh $TRS;
806 }
807
808 {
809 print "processing facedata...\n" if $VERBOSE;
324 while (my ($k, $v) = each %FACEINFO) { 810 while (my ($k, $v) = each %FACEINFO) {
325 $v->{data32} ||= delete $PNG32{$k}; 811 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
812 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
813
814 make_hash $k, $v->{data32}, $v->{hash32};
815 make_hash $k, $v->{data64}, $v->{hash64};
816
817 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
818 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
819
820 my $stem = delete $v->{stem};
821 $v->{glyph} //= autoglyph $stem, $v;
822
823 if (my $magicmap = $v->{magicmap}) {
824 $magicmap =~ y/A-Z_\-/a-z/d;
825 $v->{magicmap} = $COLOR{$magicmap};
326 } 826 }
327 827
828 delete $v->{arc};
829 }
830
831 print "processing resources...\n" if $VERBOSE;
832 my $enc = JSON::XS->new->utf8->canonical->relaxed;
328 while (my ($k, $v) = each %FACEINFO) { 833 while (my ($k, $v) = each %RESOURCE) {
329 length $v->{data32} or warn "$k: face has no png32. this will crash the server.\n";
330 834
331 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 835 if ($v->{meta} && $v->{meta}{datadir}) {
836 delete $RESOURCE{$k};
837
838 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
839
840 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
841 open my $fh, ">:raw", "$DATADIR/$k~"
842 or die "$DATADIR/$k~: $!";
843 syswrite $fh, $v->{data};
844 push @COMMIT, $k;
845
846 } else {
847 if ($v->{type} & 1) {
848 # prepend meta info
849
850 my $meta = $enc->encode ({
851 name => $k,
852 %{ $v->{meta} || {} },
853 });
854
855 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
856 }
857
858 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
332 } 859 }
860 }
333 861
862 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
863 scalar keys %FACEINFO,
864 scalar keys %ANIMINFO,
865 scalar keys %RESOURCE
866 if $VERBOSE;
867
334 open my $fh, ">:perlio", "$DATADIR/faces~" 868 open my $fh, ">:perlio", "$DATADIR/facedata~"
335 or die "$DATADIR/faces~: $!"; 869 or die "$DATADIR/facedata~: $!";
336 870
337 print $fh Storable::nfreeze \%FACEINFO; 871 print $fh nfreeze {
338 872 version => 2,
339 #use PApp::Util; warn PApp::Util::dumpval \%FACEINFO; 873 faceinfo => \%FACEINFO,
874 animinfo => \%ANIMINFO,
875 resource => \%RESOURCE,
340 } 876 };
341 877
342 for (qw(archetypes faces animations)) { 878 }
879
880 print "committing files...\n" if $VERBOSE;
881
882 for (qw(archetypes facedata treasures), @COMMIT) {
343 chmod 0644, "$DATADIR/$_~"; 883 chmod 0644, "$DATADIR/$_~";
344 rename "$DATADIR/$_~", "$DATADIR/$_"; 884 rename "$DATADIR/$_~", "$DATADIR/$_"
885 or die "$DATADIR/$_: $!";
345 } 886 }
346 887
347 die "--install-arch not fully implemented\n"; 888 print "archetype data installed successfully.\n";
348 } 889 }
349} 890}
350 891
351Getopt::Long::Configure ("bundling", "no_ignore_case"); 892Getopt::Long::Configure ("bundling", "no_ignore_case");
352GetOptions ( 893GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines